<template>
    <v-menu
        :value="value"
        offset-y
        left
        rounded="tl-lg bl-lg br-lg"
        class="mt-4"
        :close-on-content-click="false"
    >
        <template v-slot:activator="{ on, attrs }">
            <v-btn
                v-on="on"
                v-bind="attrs"
                icon small class="ma-1 pa-1 omm-action-buttons__button--attachments"
                @click="$emit('click', $event)"
            >
                <v-icon small>mdi-paperclip</v-icon>
            </v-btn>
        </template>

        <v-list dense class="omm-attachments-menu">
            <v-list-item
                v-for="(attachment, index) in attachments"
                :key="index"
                class="omm-attachments-menu-item omm-attachments-menu-item--attachment"
            >
                <v-list-item-title
                    class="omm-attachments-menu-item__title justify-space-between d-flex align-center"
                >

                    <content-editable
                        v-model="editableItems[attachment.name]"
                        :id="attachment.name"
                        :item-key="attachment.name"
                        :initial-value="attachment.label"
                        @becomeNonEditable="handleAttachmentBlur(attachment, $event)"
                    />

                    <span class="align-self-end align-content-end ml-4">
                          <app-button
                              @click="handleEditAttachmentClick(attachment)"
                              icon="mdi-form-textbox"
                              tooltipText="Rename"
                              btn-class="ma-0 pa-0"
                              class="omm-attachments-menu-item__button--rename"
                          />
                          <app-button
                              @click="handleDeleteAttachmentClick(attachment)"
                              icon="mdi-close-circle-outline"
                              tooltipText="Delete"
                              btn-class="ma-0 pa-0"
                              class="omm-attachments-menu-item__button--delete"
                          />
                    </span>


                </v-list-item-title>
            </v-list-item>
            <v-list-item class="omm-attachments-menu-item omm-attachments-menu-item--button">
                <v-list-item-title align="center">
                    <v-btn small @click="onNewAttachmentClick">New attachment
                        <v-icon small>mdi-plus</v-icon>
                    </v-btn>
                </v-list-item-title>

            </v-list-item>
        </v-list>
    </v-menu>
</template>

<script lang="ts">
import { defineComponent, nextTick, ref, Ref, set, watch } from '@vue/composition-api';
import { CreatedFile, NoteAttachment, RenameAttachmentResult } from "@/ts";
import { useAttachments, useContents } from "@/compositions";
import { openFileDialog } from "@/ipc/openFileDialog";
import { deleteAttachment, saveFile } from "@/ipc";
import AppButton from "@/components/AppButton.vue";
import ContentEditable from "@/components/ContentEditable.vue";

export default defineComponent({
    name: "AttachmentsMenu",
    props: {
        value: {
            type: Boolean,
            default: false
        },
        y: {
            type: Number,
            default: 0
        },
        x: {
            type: Number,
            default: 0
        }
    },
    components: { AppButton, ContentEditable },
    setup(props, {emit}) {
        const attachments: Ref<NoteAttachment[]> = ref(useAttachments().getCurrentAttachments.value as NoteAttachment[]);

        const closeAttachmentsMenu = () => {
            emit('input', false);
        }

        const editableItems: Ref<Record<string, boolean|undefined>> = ref({});

        /**
         * Initiates an ipc request and prompts a open file dialogue.
         */
        const onNewAttachmentClick = async () => {
            closeAttachmentsMenu();

            const createdFiles = await openFileDialog() as CreatedFile[];

            if (!createdFiles || !createdFiles.length) return;

            createdFiles.forEach((file: CreatedFile) => {
                useContents().addMetaAttachment(file.fileName, file.originalFileName);
            });

            await saveFile();
        }

        const textContainsAttachmentName = (attachmentName: string) => {
            return useContents().getCurrentText().value.includes(`@attachment/${attachmentName}`);
        }

        /**
         * Deletes an attachment, removes it from the file metadata and save the current note.
         * @param {NoteAttachment} attachment
         */
        const handleDeleteAttachmentClick = async (attachment: NoteAttachment) => {
            if (textContainsAttachmentName(attachment.name)) return; // todo: let the user know why it does not remove it

            const deletedFile = await deleteAttachment(attachment.name);

            if (!deletedFile) return; // todo: notify with some error

            useContents().removeMetaAttachment(attachment.name);

            await saveFile();
        }

        /**
         * When the edit attachment is clicked sets contenteditable true and focus on it.
         * @param {NoteAttachment} attachment
         */
        const handleEditAttachmentClick = async (attachment: NoteAttachment) => {
            const contentEditable = document.getElementById(attachment.name);
            editableItems.value[attachment.name] = true;

            await nextTick();

            contentEditable && contentEditable.focus();
        }

        /**
         * On attachment blur renames the attachments and save the file.
         * @param {NoteAttachment} attachment
         * @param {string} newLabel
         */
        const handleAttachmentBlur = async (attachment: NoteAttachment, newLabel: string) => {
            const result = useContents().renameMetaAttachment(attachment.name, newLabel);

            if (result === RenameAttachmentResult.LABEL_RENAMED_SUCCESSFULLY) {
                await saveFile();
            }
        }

        /**
         * Sets the editableItems object.
         */
        const buildEditableItemsObject = () => {
            attachments.value.forEach((attachment) => {
                if (editableItems.value[attachment.name] !== undefined) return;
                set(editableItems.value, attachment.name, false);
            });
        }

        watch(useAttachments().getCurrentAttachments, (newAttachments: NoteAttachment[]) => {
            attachments.value = newAttachments;

            buildEditableItemsObject();
        });

        return { attachments, onNewAttachmentClick, handleDeleteAttachmentClick, handleEditAttachmentClick, editableItems, handleAttachmentBlur }
    }
});
</script>

<style scoped lang="scss">
.omm-attachments-menu-item {
    &__title {
        padding: 2px;
    }
}
::v-deep {
    .omm-content-editable {
        &:focus {
            padding: 2px 5px;
            outline: 1px solid var(--v-secondary-lighten3);
        }
    }
}
</style>